<?php
/*
Plugin Name: Brifa Companion Plugin
Plugin URI:
Description: Companion Plugin for Brifa Theme
Version: 1.0
Author: Sufian
Author URI:
License: GPLv2 or later
Text Domain: brifa-companion
Domain Path: /languages/
*/

function brifac_load_text_domain() {
	load_plugin_textdomain( 'brifa-companion', false, dirname( __FILE__ ) . "/languages" );
}

add_action( 'plugins_loaded', 'brifac_load_text_domain' );

function brifac_register_my_cpts_section() {

	/**
	 * Post Type: Section.
	 */

	$labels = array(
		"name"          => __( "Section", "brifa-companion" ),
		"singular_name" => __( "Sections", "brifa-companion" ),
	);

	$args = array(
		"label"               => __( "Section", "brifa-companion" ),
		"labels"              => $labels,
		"description"         => "",
		"public"              => false,
		"publicly_queryable"  => false,
		"show_ui"             => true,
		"show_in_rest"        => false,
		"rest_base"           => "",
		"has_archive"         => false,
		"show_in_menu"        => true,
		"show_in_nav_menus"   => true,
		"exclude_from_search" => true,
		"capability_type"     => "post",
		"map_meta_cap"        => true,
		"hierarchical"        => false,
		"rewrite"             => array( "slug" => "section", "with_front" => true ),
		"query_var"           => true,
		"menu_position"       => 5,
		"menu_icon"           => "dashicons-media-document",
		"supports"            => array( "title", "editor", "thumbnail" ),
	);

	register_post_type( "section", $args );





}

add_action( 'init', 'brifac_register_my_cpts_section' );

